import { EventEmitter, OnInit } from '@angular/core';
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { ContactLogQueryStore } from "./contact-log-table-query.store";
import { ContactLogService, ContactLogFilter } from "@yukawa/chain-crm-angular-core";
import { ActivatedRoute } from '@angular/router';
import { ContactLog, Partner } from '@yukawa/chain-crm-angular-core';
export declare class ContactLogTableComponent implements OnInit {
    private service;
    private _route;
    dataSource: ContactLogQueryStore;
    Partners: Partner[];
    displayedColumns: string[];
    customColumns: any[];
    action: EventEmitter<any>;
    paginator: MatPaginator;
    sort: MatSort;
    contactLogFilter: ContactLogFilter;
    constructor(service: ContactLogService, _route: ActivatedRoute);
    ngOnInit(): void;
    ngOnDestroy(): void;
    reload(): void;
    protected applyFilter(filter: ContactLogFilter): void;
    onAction(type: string, contactLog: ContactLog | any): void;
    protected fireAction(action: any): void;
    partnerName(participantId: any): string;
}
