import { EventEmitter, OnInit } from '@angular/core';
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { RelationQueryStore } from "./relation-table-query.store";
import { ActivatedRoute, Router } from '@angular/router';
import { PartnerInfo, Relation, RelationFilter, RelationService } from "@yukawa/chain-crm-angular-core";
import { Overlay } from "@angular/cdk/overlay";
export declare class RelationTableComponent implements OnInit {
    protected service: RelationService;
    private _route;
    overlay: Overlay;
    private _router;
    dataSource: RelationQueryStore;
    displayedColumns: string[];
    customColumns: any[];
    action: EventEmitter<any>;
    paginator: MatPaginator;
    sort: MatSort;
    relationFilter: RelationFilter;
    PartnerId: string;
    role: string;
    partnerDetailsRowId: string;
    constructor(service: RelationService, _route: ActivatedRoute, overlay: Overlay, _router: Router);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onAction(type: string, relation: Relation | any): void;
    onDelete(relId: string, event: any): void;
    reload(): void;
    protected applyFilter(filter: RelationFilter): void;
    protected fireAction(action: any): void;
    openPartnerDetailOverlay(id: any): void;
    protected isPartnerSource(row: Relation): boolean;
    getSelectedPartnerName(row: Relation): string;
    getSelectedPartnerId(row: Relation): string;
    getDisplayedRelationName(row: Relation): string;
    getDisplayedClassifier(row: Relation): string;
    getSelectedPartner(row: Relation): PartnerInfo;
    onOverlayAction(action: string): void;
    navigateToPartner(row: any): void;
}
